import os
import time
from qommon.storage import StorableObject

from categories import Category

class Comment:
    user_id = None
    user_name = None
    user_email = None
    user_website = None
    issued = None
    content = None
    content_format = 'plain'
    content_html = None

class Post(StorableObject):
    _names = 'posts'

    url_name = None
    user_id = None
    category_id = None
    title = None
    content = None
    content_format = 'rest'
    content_html = None
    issued = None
    modified = None
    language = None
    comments = None
    comments_closed = False

    def get_url(self):
        return '/%d/%02d/%02d/%s/' % tuple(list(self.issued[:3]) + [self.url_name])

    def select_category(cls, category_id, order_by = None):
        return cls.select(lambda x: x.category_id == category_id, order_by = order_by)
    select_category = classmethod(select_category)

    def get_allow_comments(self):
        return False
        if self.comments_closed:
            return False
        if not self.comments and time.mktime(
                time.localtime()) > (time.mktime(self.issued) + 14 * 86400):
            return False
        return True
    allow_comments = property(get_allow_comments)

    def sorted_keys(cls):
        # this only works when all keys are integers
        if not os.path.exists(cls.get_objects_dir()):
            return []
        keys = [int(x) for x in os.listdir(cls.get_objects_dir())]
        keys.sort()
        return [str(x) for x in keys]
    sorted_keys = classmethod(sorted_keys)


    def get_category(self):
        return Category.get(self.category_id)
    category = property(get_category)
