import os
import sys
import time

from Defaults import *

try:
    from chlorophyll_cfg import *
except ImportError:
    pass

from qommon.publisher import QommonPublisher, set_publisher_class
from qommon.cron import CronJob
from qommon import get_cfg

from root import RootDirectory
import sessions

from users import User


class ChlorophyllPublisher(QommonPublisher):
    APP_NAME = 'chlorophyll'
    APP_DIR = APP_DIR
    DATA_DIR = DATA_DIR
    ERROR_LOG = ERROR_LOG

    supported_languages = ['en', 'fr']

    root_directory_class = RootDirectory
    session_manager_class = sessions.StorageSessionManager
    user_class = User
    site_charset = 'utf-8'

    def get_admin_module(cls):
        import admin
        return admin
    get_admin_module = classmethod(get_admin_module)

    def register_ident_methods(cls):
        import qommon.ident.password
        cls.ident_methods = {}
        for klass in (qommon.ident.password.PasswordAuthMethod, ):
            cls.ident_methods[klass.key] = klass
    register_ident_methods = classmethod(register_ident_methods)

set_publisher_class(ChlorophyllPublisher)
